"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const writePkg = require("write-pkg");
const base_1 = require("../base");
const conf_1 = require("../services/conf");
const logger_1 = require("../services/logger");
const track_1 = require("../services/track");
const validate_1 = require("../services/validate");
const util_1 = require("../util");
class Publish extends base_1.default {
    async preInit() {
        await this.config.runHook('checkUpdate', {});
        const { flags } = this.parse(Publish);
        this.rdcConf = await validate_1.validateRdc(false);
        return flags;
    }
    async initialize() {
        const json = this.rdcConf.npm || {};
        json.files = [
            'app',
            'template',
            'rdc.config.js',
            'abc.json'
        ];
        await writePkg(conf_1.default.cwd, json);
    }
    async run() {
        track_1.uploadHubble({ cmd: 'publish' });
        await util_1.default.asyncSpawn('npm', ['publish']);
        await util_1.default.asyncSpawn('rm', ['package.json']);
    }
    async postRun() {
        logger_1.logger.log('Published successfully');
    }
}
Publish.examples = [
    '$ rde publish',
];
Publish.flags = Object.assign({}, base_1.default.flags);
exports.default = Publish;
